C
C------------------------------------------------------
      SUBROUTINE BARIC(Q,INF,ISUP,BAR,EPLA4,INDEX)
C------------------------------------------------------
      INCLUDE 'INTEST.TXT'
      REAL Q(NCHA)
      REAL BAR

      COMMON / SHIFT / SHIFT
      SAVE / SHIFT /

      CM = 0.
      EPLA4 = 0.
      DO LL = INF,ISUP
        ENN = Q(LL)
        IF (ENN.GT.EMIN) THEN
C
          CALL MILLIM(LL,RMM)
          CM = CM + RMM * ENN
          EPLA4 = EPLA4 + ENN
        ENDIF
      ENDDO
      IF (EPLA4.EQ.0) GO TO 300
      BAR = CM / EPLA4
      GOTO 400
C
  300 INDEX = 0
      GOTO 500
C
  400 INDEX = 1
C
  500 CONTINUE
      RETURN
      END
C
